#version 450

#extension GL_ARB_separate_shader_objects : enable
#extension GL_ARB_shading_language_420pack : enable

struct Material {
	vec4 albedo;
	vec4 A;
	vec4 mu_o;
	vec4 mu_e;
	float eta_o;
	float eta_e;
	float _unused0, _unused1;
};

layout (binding = 0) uniform sampler2D samplerColor0;
layout (binding = 1) uniform Params {
	Material material;
	float exposure;
	float polarization;
	float d;
} params;

layout (location = 0) in vec2 inUV;

layout (location = 0) out vec4 outColor;

void main() 
{
	const float gamma = 2.2;

	const vec3 hdr = texture(samplerColor0, inUV).rgb;

	// Tonemap and gamma correct
	const vec3 final = vec3(1.0) - exp(-hdr * params.exposure);
	outColor = vec4(pow(final, vec3(1.0 / gamma)), 1);
}
